<?php

// If we are outside SMF throw an error.
if (!defined('SMF'))
	die('Hacking attempt...');

//Insert profile visitors for this member.	
function LogVisitors()
{
	global $smcFunc, $user_info, $context, $modSettings;
	
	//Get member.
	$memID = !empty($_REQUEST['u']) ? (int) $_REQUEST['u'] : 0;

	//Do not log own profile views.
	if ($context['user']['is_owner'])
	{    
	    return;
	}
	
	//Log admin profile views?
	if(!empty($modSettings['log_admin_profile_vists']) && $context['user']['is_admin'])
	{    
	    return;
	}
	
	//Log guests profile views?
	if(!empty($modSettings['log_guests_profile_vists']) && $context['user']['is_guest'])
	{    
	    return;
	}
	
    //Insert profile visitors in the database for existing members.
	if (!empty($memID))
	{
	     $smcFunc['db_insert']('ignore',
			   '{db_prefix}log_profile_visitors',
			    array('id_visitor' => 'int', 'id_visited_member' => 'int', 'time' => 'int'),
			    array($user_info['id'], $memID, time()),
			    array('id_visitor', 'id_visited_member')
	     );
	}
}

//Display profile visitors for this member.
function DisplayProfileVisitors($memID)
{
	global $smcFunc, $user_info, $scripturl, $modSettings, $context, $txt;
	
	//Hw many visitors to show?
	$modSettings['visitor_limit'] = !empty($modSettings['visitor_limit']) ? (int) $modSettings['visitor_limit'] : 5 ; 

	$views = $smcFunc['db_query']('', '
		SELECT
			pv.id_visited_member, pv.id_visitor, mem.id_member, mem.real_name, mem.avatar, mg.online_color, MAX(pv.time) as last_visit,
			IFNULL(a.id_attach, 0) AS id_attach, a.filename, a.attachment_type
		    FROM {db_prefix}log_profile_visitors AS pv
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = pv.id_visitor)
			LEFT JOIN {db_prefix}membergroups mg ON (mem.id_group = mg.id_group)
	        LEFT JOIN {db_prefix}attachments AS a ON (a.id_member = mem.id_member)  
		WHERE pv.id_visited_member = {int:visited}
		GROUP BY pv.id_visitor
		ORDER BY last_visit DESC
		LIMIT {int:limit}',
		array(
			'visited' => $memID,
			'limit' => (int) $modSettings['visitor_limit'],
		)
	);
	
	// Array to store the visitor data in.
	$context['profile_visitors'] = array();
	
	//Loop throw visitors.
	while ($row = $smcFunc['db_fetch_assoc']($views))
	{
		$context['profile_visitors'][] = array(
			'name' => !empty($row['real_name']) ? $row['real_name'] : $txt['visitor_is_guest'],
			'id_visitor' => !empty($row['id_visitor']) ? $row['id_visitor'] : '0',
			'avatar' => array(
			     'name' => $row['avatar'],
			     'image' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? '<img src="' . (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
			     'href' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
			     'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar'])
		    ),
			'online_color' => !empty($row['online_color']) ? $row['online_color'] : '',
			'last_visit' => !empty($row['last_visit']) ? strftime('%H:%M:%S', $row['last_visit']) : '',
			
		);
	}
	
	$smcFunc['db_free_result']($views);

}

//Set up the permisisons who can view profile visitors.
function load_profile_visitors_permissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{ 
	$permissionList['membergroup']['profilevisitors_view'] = array(true, 'profile', 'view_basic_info', 'view_basic_info');
}

//Load our custom language.
function load_profile_visitors_language()
{
	loadLanguage('ProfileVisitors');
}

//Add the mod settings in the admin panel.	
function VisitorsAdminArea(&$admin_areas)
{
	global $txt;
	
	return $admin_areas['config']['areas']['modsettings']['subsections'] += array('profilevisitors' => array(sprintf($txt['profilevisitors_settings'])));
}

//Set the link action for the setting.
function VisitorsSubAction(&$subActions)
{
	return $subActions += array('profilevisitors' => 'VisitorsSettings');
}

//Add mod settings.
function VisitorsSettings($return_config = false) 
{
	global $context, $txt, $scripturl, $modSettings, $smcFunc;

	$context['page_title'] = $txt['profilevisitors_settings'];
	
	$config_vars = array(
		array('text', 'visitor_limit'),
		array('check', 'log_admin_profile_vists'),
		array('check', 'log_guests_profile_vists'),
	);

	if ($return_config)
		return $config_vars;

	if (isset($_GET['save'])) 
	{
		checkSession();

		saveDBSettings($config_vars);
		
		writeLog();

		redirectexit('action=admin;area=modsettings;sa=profilevisitors');
	}

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=profilevisitors';

	prepareDBSettingContext($config_vars);
}